# Contribution Guide

Hello 👋!

Thank you for viewing our Contribution Guide. We're grateful for your help, and we're excited you're here.

Feel free to take a moment to view our [Code of Conduct](CODE-OF-CONDUCT.md) as well.

## Primary Goals for `wasp-graphql`

1 - Small: Provide a thin wrapper around XmlHttpRequest, and keep the package size small

2 - Interoperable: Make it easy for others to extend `wasp-graphql` for their own libraries, and maintain interoperability with as many GraphQL technologies as possible

3 - Simple: Maintain an intuitive, predictable API

## Ways to get involved

- [Report Issues or Offer Suggestions](https://github.com/BlackWaspTech/wasp-graphql/issues)

- [Send a Pull Request with](https://www.thinkful.com/learn/github-pull-request-tutorial/)

  - Improve our documentation!
  - Bug fixes
  - More tests
  - New features (please submit an [Issue](https://github.com/BlackWaspTech/wasp-graphql/issues) first to make sure it fits the project scope)

## Contributing Code

### Git Workflow ([more information](https://guides.github.com/introduction/flow/))

All contributions must be offered via [Pull Request](https://help.github.com/articles/about-pull-requests/) and be approved by a maintainer.

Make all pull requests to the `master` branch.

### Code Style

There's no need to worry about style. [Prettier](https://prettier.io/) has been configured, and it'll auto-format your code as soon as it's committed.

See the [Airbnb Style Guide](https://github.com/airbnb/javascript) for more information.

### Continuous Integration (CI)

- Write tests for your code
- Pass the test for your code
- Add more tests to other people's code

We're running [Jest](https://jestjs.io/en/) for our test suite.

Available commands:

- `yarn test` / `npm test` to run all tests
- `yarn test:watch` / `npm run test:watch` to run the test watcher
- `yarn test:coverage` / `npm run test:coverage` to generate a coverage report

---

View the [Changelog](CHANGELOG.md)

Return to [README](README.md)
